{
BASS Simple Console Test, copyright (c) 1999-2000 Ian Luck.
==============================================================
Delphi version by Titus Miloi (titus.a.m@t-online.de)
}
program ConTest;

uses Windows, SysUtils, BASS, MMSystem, crt,VpSysLow,WinDos,_func;


var
  starttime: DWORD;
Const
  A1=#201;(* ਠ*)
  A2=#200;
  A3=#187;
  A4=#188;
  A5=#205;
  A6=#186;

function IntToFixed(val, digits: Integer): string;
var
  s: string;
begin
  s := SysUtils.IntToStr(val);
  while Length(s) < digits do s := '0' + s;
  Result := s;
end;

// display error messages
procedure Error(text: string);
begin
  Window(1,1,80,25);
  TextColor(15);
  TextBackGround(0);
  WriteLn('Error(' + SysUtils.IntToStr(BASS_ErrorGetCode) + '): ' + text);
  BASS_Free;
  Halt(0);
end;

// looping synchronizer, resets the clock
procedure LoopSync(handle: HSYNC; channel, data, user: DWORD); stdcall;
begin
  starttime := timeGetTime;
end;

var
  mus: HMUSIC;
  str: HSTREAM;
  chn: DWORD;
  time, pos, level: DWORD;
  a: Integer;
  freq, other: DWORD;
  mono: Boolean;
  temppChar:Pchar;
  tempStr:String;
  Var I,J:Byte;
  _Name:String;
begin
  mono := FALSE;
  // check that BASS 1.8 was loaded
  if (BASS_GetVersion <> MAKELONG(1, 8)) then
  begin
    Writeln('BASS version 1.8 was not loaded');
    Exit;
  end;
  if (ParamCount <> 1) then
  begin
    WriteLn('usage: contest <file>');
    Exit;
  end;

  // setup output - default device, 44100hz, stereo, 16 bits
  if not BASS_Init(-1, 44100, 0, GetForegroundWindow) then
    Error('Can''t initialize device');

  // try streaming the file
  mus := 0;
  tempStr:=paramstr(1)+#0;
  temppchar:=@tempstr[1];

  {$IFDEF VIRTUALPASCAL}
  SysTVSetCurType(0, 0, False);   // Hide Cursor
  {$ENDIF}
  Window(22,5,59,13);
  TextBackground(15);
  TextColor(0);
  ClrScr;
  GotoXY(4,2);
  Write(A1);
  For I:=5 To 34 Do
    Write(A5);
  Write(A3);
  For J:=3 To 7 Do
  Begin
    GotoXY(4,J);
    Write(A6);
    GotoXY(35,J);
    Write(A6);
  End;
  GotoXY(4,8);
  Write(A2);
  For I:=5 To 34 Do Write(A5);Write(A4);
  GotoXY(17,2);
  Writeln(' Play ');
  GotoXY(12,3);
  Write('Playing the file');
  _Name:=Ansi2866(ExtractFileName(ParamStr(1)));
  GotoXY(15-Length(_Name) div 2+5,4);
  Write(_Name);

  str := BASS_StreamCreateFile(FALSE, temppchar, 0, 0, 0);
  if (str <> 0) then
  begin
    mono := (BASS_ChannelGetFlags(str) and BASS_SAMPLE_MONO) <> 0;
    BASS_ChannelSetSync(str, BASS_SYNC_END, 0, LoopSync, 0);
  end
  else
  begin
    // load the MOD (with looping and normal ramping)
    mus := BASS_MusicLoad(FALSE, temppchar, 0, 0, BASS_MUSIC_LOOP or BASS_MUSIC_RAMP);
    if (mus = 0) then
      // not a MOD either
      Error('Can''t play the file');
    // set a synchronizer for when the MOD reaches the end
    BASS_ChannelSetSync(mus, BASS_SYNC_END, 0, LoopSync, 0);
  end;

  BASS_Start;
  if (str <> 0) then
    BASS_StreamPlay(str, FALSE, BASS_SAMPLE_LOOP)
  else
    BASS_MusicPlayEx(mus, 0, -1, TRUE);
  starttime := timeGetTime;

  chn := str;
  if chn = 0 then chn := mus;
  while (not KeyPressed) and (BASS_ChannelIsActive(chn)=1) do
  begin
    // display some stuff and wait a bit
    time := timeGetTime - starttime;
    level := BASS_ChannelGetLevel(chn);
    pos := BASS_ChannelGetPosition(chn);
    GotoXY(28,8);
    if (str <> 0) then
        Write(' '+IntToFixed((time div 60000),2) + ':' + IntToFixed((time div 1000) mod 60, 2)+' ');
{    Write(' R - cpu ' + FloatToStrF(BASS_GetCPU, ffFixed, 0, 1) + '%  ' + #13);}
    TextColor(1);
    GotoXY(9,6);a := 1;
    while (a < 128) do
    begin
      if HIWORD(level) >= a then
         Write('')
      else
         Write('--');
      a := 2 * a - a div 2;
    end;
    gotoxy(9,7);a:=1;
    while (a < 128) do
    begin
      if LOWORD(level) >= a then
         Write('')
      else
         Write('--');
      a := 2 * a - a div 2;
    end;
    Sleep(50);
  end;
  BASS_Free;
end.
